/**
 * This file is part of ArmarX.
 *
 * ArmarX is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * ArmarX is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * @author     Tobias Gröger ( tobias dot groeger at student dot kit dot edu )
 * @date       2022
 * @copyright  http://www.gnu.org/licenses/gpl-2.0.txt
 *             GNU General Public License
 */

#pragma once

#include <ArmarXCore/core/time.h>

#include <armarx/navigation/core/basic_types.h>

namespace armarx::navigation::human
{
    struct Human
    {
        core::Pose2D pose;
        Eigen::Vector2f linearVelocity;
        DateTime detectionTime;

        core::Pose2D estimateAt(DateTime& time) const;
    };

    struct HumanGroup
    {
        std::vector<Eigen::Vector2f> vertices;
        std::vector<Human> humans;
        DateTime detectionTime;
    };

    struct ProxemicZone
    {
        core::Pose2D pose;
    };

} // namespace armarx::navigation::human
