#include "TebObstacleManager.h"

#include <ArmarXCore/core/logging/Logging.h>

#include <armarx/navigation/local_planning/ros_conversions.h>

namespace armarx::navigation::local_planning
{

    void
    TebObstacleManager::clear()
    {
        container.clear();
    }

    size_t
    TebObstacleManager::size()
    {
        return container.size();
    }

    void
    TebObstacleManager::addBoxObstacle(const VirtualRobot::BoundingBox& bbox)
    {
        auto obst = boost::make_shared<teb_local_planner::PolygonObstacle>();

        const Eigen::Vector2d min = conv::toRos(bbox.getMin());
        const Eigen::Vector2d max = conv::toRos(bbox.getMin());

        obst->pushBackVertex(min);
        obst->pushBackVertex(max);
        obst->pushBackVertex(min.x(), max.y());
        obst->pushBackVertex(max.x(), min.y());

        obst->finalizePolygon();
        container.push_back(obst);
    }

} // namespace armarx::navigation::local_planning
